package com.fuzamei.dao;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.fuzamei.entity.ContractRecord;
import com.fuzamei.entity.ContractStatusTracking;
import com.fuzamei.mapperInterface.ContractManagementMapper;

@Repository
public class ContractManagementDao {
	
	@Autowired
	private ContractManagementMapper contractManagementMapper;

	public List<ContractStatusTracking> queryContractStatusTracking(Map<String, Object> map) {
		return contractManagementMapper.queryContractStatusTracking(map);
	}

	public int findAllContractStatusTrackingInformation(Map<String, Object> map) {
		return contractManagementMapper.findAllContractStatusTrackingInformation(map);
	}

	public List<ContractRecord> queryContractRecord(Map<String, Object> map) {
		return contractManagementMapper.queryContractRecord(map);
	}

	public int findAllContractRecordInformation(Map<String, Object> map) {
		return contractManagementMapper.findAllContractRecordInformation(map);
	}

	public ContractStatusTracking getContractStatusTrackingByBusinessId(Integer businessId) {
		return contractManagementMapper.getContractStatusTrackingByBusinessId(businessId);
	}

	public void insertInformationToAttachment(Map<String, Object> map) {
		contractManagementMapper.insertInformationToAttachment(map);
	}

	public void insertInformationToOperationHistory(Map<String, Object> map) {
		contractManagementMapper.insertInformationToOperationHistory(map);
	}

	public ContractRecord getLatestContractRecordByBusinessId(Integer businessId) {
		return contractManagementMapper.getLatestContractRecordByBusinessId(businessId);
	}

	public void insertInformationToContractRecord(Map<String, Object> map) {
		contractManagementMapper.insertInformationToContractRecord(map);
	}

	public void updateContractStatusTracking(Map<String, Object> map) {
		contractManagementMapper.updateContractStatusTracking(map);
	}

	public ContractRecord getCurrentContractRecordByBusinessId(Integer businessId, Integer version) {
		return contractManagementMapper.getCurrentContractRecordByBusinessId(businessId,version);
	}

	public void updateContractRecord(Map<String, Object> map) {
		contractManagementMapper.updateContractRecord(map);
	}

	public void updateOtherContractRecord(Map<String, Object> map) {
		contractManagementMapper.updateOtherContractRecord(map);
	}

	public void updateContractStatusTrackingStatusAndContractId(Map<String, Object> map) {
		contractManagementMapper.updateContractStatusTrackingStatusAndContractId(map);
	}
}
