package com.fuzamei.web;

import java.io.File;
import java.io.IOException;
import java.util.LinkedHashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import com.fuzamei.constant.HintMSG;
import com.fuzamei.constant.Role;
import com.fuzamei.entity.UserDetail;
import com.fuzamei.service.TrueFalseSelectService;
import com.fuzamei.service.UserAuthoricationService;
import com.fuzamei.utils.HashXiZhiUtil;
import com.fuzamei.utils.JSONUtil;
import com.fuzamei.utils.ValidationUtil;

/**
 * 
 * @author chb & ylx
 * @describe 真伪查询模块
 * @date 2018-1-4 12:17
 */
@Controller
@RequestMapping(value = "/query_true_or_false")
public class TrueFalseSelectAction {
	
	@Autowired
	private TrueFalseSelectService trueFalseSelectService;
	
	private static final String SP = File.separator;

	@Autowired
	private UserAuthoricationService userAuthoricationService;
	/**  
     * 真伪查询 上传文件  产生一条哈希值
     * 判断hash值是否有效？？？
     * @param  
     * @param   
     * @throws Exception  
     */  
    @RequestMapping(value="/trueFalseSelect",method=RequestMethod.POST)  
    @ResponseBody  
    public Map<String,Object> trueFalseSelect(@RequestParam("file") MultipartFile file,
    										  HttpServletRequest request,
    										  @RequestParam("userId") Object uId) throws IOException{  
       try {
    	   	//非空校验
		   	if(file.isEmpty()){
		   		throw new RuntimeException("上传文件不能为空");
		   	}
		   	int userId = ValidationUtil.checkAndAssignInt(uId);//对用户id进行校验
		   	UserDetail userDetail = userAuthoricationService.checkUserAuthority(userId,Role.INNERS_OF_BANK);//获取用户详细信息
		   	
		   	String path = request.getServletContext().getRealPath("")+SP+"content"; //==>>待定TODO
	       	
	       	//MultipartFile自带的解析方法  
	       	String fileName = file.getOriginalFilename();  
	       	String pathFile=path+"/"+fileName;
	       	File newfile = new File(pathFile);
	       	File dir = new File(path);
	       	//======文件开始上传=======
	       	if(!dir.exists()){  
	           	dir.mkdirs();  
	       	}  
	       	file.transferTo(newfile);
	       	//======文件上传结束=======
	       	//是上传文件之后才会产生一条哈希值的  然后在对哈希值做操作
	       	// HashXiZhiUtil.getMd5("D:\\xiangnu\\123.doc");
	       	String hash=HashXiZhiUtil.getMD5Checksum(pathFile);//调用方法 对（文件）产生一条哈希值
	      	newfile.delete();
		  	Map<String, Object> mapToService = new LinkedHashMap<String, Object>();
		  	mapToService.put("hash", hash);
		  	mapToService.put("userDetail", userDetail);
		  	boolean flag=trueFalseSelectService.insertTrueFalseSelect(mapToService);
		  	System.out.println(hash);
       	 	return JSONUtil.getJsonMap(200, true, HintMSG.CHECK_SUCCESS, flag);
		}catch (Exception e) {
			return JSONUtil.getJsonMap(500, false, HintMSG.CHECK_FAIL+":"+e.getMessage(), null);
		}
    }  
	
}
